/*******************************************************************************
 * FoxWeapon_HMGBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxWeapon_HMGBase extends FoxWeapon_AutomaticRifleBase
    config(HardSuitWeapons)
    hidecategories(Navigation);

var private const float WarmupFireTime;
var private transient float StartWarmUpTime;
var private AkEvent WarmUpEvent;
var private transient bool bWarmedUp;

simulated function TryToGetBackToFiringState()
{
    //return;    
}

simulated function TryToGetBackToZoom()
{
    //return;    
}

simulated state WeaponFiring
{
    simulated function BeginState(name PreviousStateName)
    {
        StartWarmUpTime = WorldInfo.TimeSeconds;
        bWarmedUp = false;
        Instigator.PostAkEvent(WarmUpEvent);
        super.BeginState(PreviousStateName);
        //return;        
    }

    simulated function StartFiringSound(const byte FireModeNum)
    {
        // End:0x20
        if(bWarmedUp)
        {
            super(FoxWeapon).StartFiringSound(FireModeNum);
        }
        //return;        
    }

    simulated function FireAmmunition()
    {
        local float ElapsedTime;

        ElapsedTime = WorldInfo.TimeSeconds - StartWarmUpTime;
        // End:0x8A
        if(bWarmedUp || ElapsedTime > WarmupFireTime)
        {
            // End:0x80
            if(!bWarmedUp)
            {
                bWarmedUp = true;
                StartFiringSound(0);
            }
            super(FoxWeapon).FireAmmunition();
        }
        //return;        
    }
    stop;    
}

defaultproperties
{
    WarmupFireTime=0.40
    WarmUpEvent=AkEvent'A_Hardsuit.Play_Chaingun_Rev'
    WeaponSlot=EAttachSlot.EASlot_LeftHand
    FireFeedbackWaveform=ForceFeedbackWaveform'Default__FoxWeapon_HMGBase.ForceFeedbackWaveformFire'
    TightAimCameraShake=CameraShake'Default__FoxWeapon_HMGBase.Shake0'
    NormalCameraShake=CameraShake'Default__FoxWeapon_HMGBase.Shake1'
    MuzzleFlashLight=PointLightComponent'Default__FoxWeapon_HMGBase.LightComponent0'
    begin object name=MuzFlashParticleSystemComponent0 class=FoxFirstPersonParticleSystemComponent
        Template=ParticleSystem'FX_MuzzleFlash.FX_HardSuit_MachineGun.PS_MF_HardSuit_MachineGun'
        bAutoActivate=false
        ReplacementPrimitive=none
    object end
    // Reference: FoxFirstPersonParticleSystemComponent'Default__FoxWeapon_HMGBase.MuzFlashParticleSystemComponent0'
    MuzFlashEmitter=MuzFlashParticleSystemComponent0
    begin object name=LensComp class=LensFlareComponent
        NextTraceTime=-0.40980260
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxWeapon_HMGBase.LensComp'
    MuzzleLensFlare=LensComp
    FireSound=AkEvent'A_Hardsuit.Play_FireLoop_ChainGun_1st'
    TailSound=AkEvent'A_Hardsuit.Stop_FireLoop_ChainGun_1st'
    AN_FullReload=(TP_Anim=(AnimName=(None,None,None,None,Reload_L)),FP_Anim=None,WP_Anim=None)
    AN_NormalFire=(TP_Anim=(AnimName=(None,None,None,None,Attack_L_A)),FP_Anim=None,WP_Anim=None)
    begin object name=WeaponMesh class=FoxFirstPersonSkeletalMeshComponent
        SkeletalMesh=SkeletalMesh'WPN_HardSuit_GunPod.Mesh.SK_WPN_HardSuit_GunPod'
        AnimTreeTemplate=AnimTree'AN_AnimTree_BL2.AnimTree.AN_WeaponsTree'
        ReplacementPrimitive=none
    object end
    // Reference: FoxFirstPersonSkeletalMeshComponent'Default__FoxWeapon_HMGBase.WeaponMesh'
    Mesh=WeaponMesh
}